import os
import pandas as pd
import xarray as xr
import aerosol.functions as af
import numpy as np
import matplotlib.pyplot as plt
import pytz
tz = pytz.FixedOffset(420)
import glob
import os
import pandas as pd
import xarray as xr
import aerosol.functions as af
import numpy as np
from aerosol.functions import calc_conc
import matplotlib.pyplot as plt
import seaborn as sns
import scipy
from scipy.stats import norm

from scipy.optimize import curve_fit

# Seasonal colors
seasonal_colors = {
    'winter': 'blue',
    'summer': 'green',
    'autumn': 'orange',
    'spring': 'magenta'
}



df = pd.read_csv("all_particle_data_1h.csv", index_col=0,parse_dates=True)
df = df.iloc[:,df.columns.values.astype(float)>=2e-9]
df.index = df.index.tz_localize('UTC').tz_convert(tz)
conc = af.calc_conc(df,2.5e-9,5e-9)
days = pd.to_datetime(df.index.strftime("%Y%m%d"))

rank = conc.resample("1d").max()
rank.index = pd.to_datetime(rank.index.strftime("%Y%m%d"))

rank = rank.dropna()

prctiles = np.array([0,5,10,15,20,25,30,35,40,45,50,55,60,65,70,75,80,85,90,95,100])*0.01
rank_percentiles = rank.quantile(prctiles).values.squeeze()

df_master = pd.DataFrame(index=rank.index,columns=["rank"],data=rank.values)
df_master["prc"]=np.nan
df_master["class"]=np.nan


for i in range(0,len(rank_percentiles)-1):
    prc_days = rank.index[(rank.values.squeeze()>=rank_percentiles[i]) & (rank.values.squeeze()<=rank_percentiles[i+1])]
    df_master.loc[prc_days,["prc"]]=prctiles[i+1]*100
    #median_df_in_prc = df_in_prc.groupby("hour").median()
    #median_df_in_prc.index = [pd.to_datetime("2013-01-01") + pd.Timedelta(hours=y) for y in median_df_in_prc.index.values]
    #median_dfs.append(median_df_in_prc)

'''
import datetime

fin = np.loadtxt('/home/demakova/Documents/Classification_gases/events_2020.csv', delimiter = ',')
event = np.array(fin, dtype = 'int')
event = np.array([datetime.datetime(s[2], s[1], s[0]) for s in event])
event_days = pd.to_datetime(event)


fin2 = np.loadtxt('/home/demakova/Documents/Classification_gases/nonevents_2020.csv', delimiter = ',')
nonevent = np.array(fin2, dtype = 'int')
nonevent = np.array([datetime.datetime(s[2], s[1], s[0]) for s in nonevent])
nonevent_days = pd.to_datetime(nonevent)

fin3 = np.loadtxt('/home/demakova/Documents/Classification_gases/undefined_2020.csv', delimiter = ',')
undefined = np.array(fin3, dtype = 'int')
undefined = np.array([datetime.datetime(s[2], s[1], s[0]) for s in undefined])
undefined_days = pd.to_datetime(undefined)

df_master.loc[event_days,["class"]]="event"
df_master.loc[nonevent_days,["class"]]="nonevent"
df_master.loc[undefined_days,["class"]]="undefined"

df_master = df_master.dropna()

'''

# Gases and radiation data
# Read SO2 data with DateTime as index
so2_data = pd.read_csv(
    '/home/demakova/Documents/gases/Gases/so2.csv',
    skiprows=[1], 
    encoding='utf-8',
    usecols=['DateTime', 'Detrended_SO2'],
    parse_dates=['DateTime']  # Parse DateTime column as datetime objects
)
# Set DateTime as the index
so2_data.set_index('DateTime', inplace=True)
o3_data = pd.read_csv('/home/demakova/Documents/Classification_gases/FON_O3.csv',skiprows=[1,],index_col=0,parse_dates=[[0,1]], date_format="%d/%m/%Y %H:%M:%S")
nox_data = pd.read_csv('/home/demakova/Documents/Classification_gases/FON_NOx.csv',skiprows=[1,],index_col=0,parse_dates=[[0,1]], date_format="%d/%m/%Y %H:%M:%S")
rad_data = pd.read_csv('/home/demakova/Documents/Classification_gases/FON_meteo.csv',skiprows=[1,],index_col=0,parse_dates=[[0,1]], date_format="%d/%m/%Y %H:%M:%S")


#so2_data = so2_data.drop_duplicates()
#o3_data = o3_data.drop_duplicates()
#noc_data = nox_data.drop_duplicates()
#rad_data = rad_data.drop_duplicates()
#so2_data = so2_data.drop_duplicates()



# Combine gas and radiation data
gasrad_df = pd.concat((
    so2_data.iloc[:,0],
    o3_data.iloc[:,0],
    nox_data.iloc[:,0],
    nox_data.iloc[:,4],
    rad_data.iloc[:,32],
    rad_data.iloc[:,6],
    rad_data.iloc[:,14],
    rad_data.iloc[:,22],
    rad_data.iloc[:,28],
    ),axis=1,join="outer")

gasrad_df.columns = ["SO2 (ppb)",
                     "O3 (ppb)",
                     "NO (ppb)",
                     "NO2 (ppb)",
                     "Global rad (W m$^{-2}$)",
                     "Temperature (C)",
                     "RH (%)",
                     "Wind speed (m s$^{-1}$)",
                     "Wind direction ($^{\circ}$)"]

# convert to ppb
so2_m = 0.350
no_m = 30.006
no2_m = 46.005

gasrad_df.iloc[:,0] = ((gasrad_df.iloc[:,0]*so2_m))
gasrad_df.iloc[:,2] = ((gasrad_df.iloc[:,2] * 24.45) / no_m)
gasrad_df.iloc[:,3] = ((gasrad_df.iloc[:,3] * 24.45) / no2_m)


# median 11-14 for each day
gasrad_df = gasrad_df.iloc[((gasrad_df.index.hour<=14) & (gasrad_df.index.hour>=10)),:]
gasrad_df = gasrad_df.resample("1D").median()
gasrad_df = gasrad_df.drop_duplicates()

df_master = pd.concat((df_master["rank"],gasrad_df),axis=1,join="inner")

# Find 45th and 70th percentile rank
lo_hi_percentiles = df_master["rank"].quantile((0.0,0.4,0.85,1.0)).values

import matplotlib.colors as mcolors

# Define colormap
cmap = mcolors.ListedColormap([seasonal_colors['winter'], seasonal_colors['spring'], seasonal_colors['summer'], seasonal_colors['autumn']])
bounds = [0, 3, 6, 9, 12]
norm = mcolors.BoundaryNorm(bounds, cmap.N)

# Plotting section with switched axes, vertical shading, and larger tick fonts
fig, ax = plt.subplots(3, 3, figsize=(16, 16))
ax = ax.flatten()

for i in range(9):
    # Vertical shading for the new axis (previously horizontal)
    ax[i].axvspan(lo_hi_percentiles[0], lo_hi_percentiles[1], color='tab:green', alpha=0.2)
    ax[i].axvspan(lo_hi_percentiles[2], lo_hi_percentiles[3], color='tab:blue', alpha=0.2)

    month_values = df_master.index.month.values
    
    # Switched x and y axes
    sc = ax[i].scatter(df_master['rank'], df_master.iloc[:, i+1],
                       c=month_values, cmap=cmap, norm=norm, s=30)
    
    # Set the x and y labels with large fonts
    ax[i].set_xlabel(r"$\Delta N_{2.5-5}$", fontsize=30)  # Y-axis
    ax[i].set_ylabel(df_master.columns[i+1], fontsize=30)  # X-axis
    
    ax[i].set_xscale("log")  # Log scale for rank (Y-axis)
    if i in [0, 1, 2, 3, 4]:
        ax[i].set_yscale("log")  # Log scale for selected parameters
    
    # Title with large font size
    #ax[i].set_title(df_master.columns[i+1], fontsize=25)
    ax[i].set_xlim((lo_hi_percentiles[0], lo_hi_percentiles[3]))
    
    # Set bigger font size for ticks
    ax[i].tick_params(axis='both', which='major', labelsize=30)  # Increased tick font size

# Adjust layout
plt.tight_layout()

# Add colorbar
cb_ax = fig.add_axes([0.99999, 0.15, 0.02, 0.7])  # [left, bottom, width, height]
cbar = fig.colorbar(sc, cax=cb_ax, ticks=[2.5, 5, 7.5, 10])
cbar.ax.set_yticklabels(['Winter', 'Spring', 'Summer', 'Autumn'], fontsize=20)  # Larger tick labels for colorbar
#cbar.set_label('Season', fontsize=25)

# Save the figure with high resolution
plt.savefig("rank_vs_gases_switched_axes_larger_ticks.png", dpi=300, bbox_inches="tight")
plt.show()






import scipy.stats as stats


# Function to get season based on month
def get_season(month):
    if month in [12, 1, 2]:
        return 'winter'
    elif month in [3, 4, 5]:
        return 'spring'
    elif month in [6, 7, 8]:
        return 'summer'
    elif month in [9, 10, 11]:
        return 'autumn'

# Add a 'season' column to the dataframe
df_master['season'] = df_master.index.month.map(get_season)

# List of parameters (excluding 'rank' which is the dependent variable)
parameters = df_master.columns[1:len(df_master.columns)-1]  # exclude 'rank' and 'season'

# Loop through each parameter and season to compute R and p-values
seasons = ['winter', 'spring', 'summer', 'autumn']
for season in seasons:
    print(f"\nSeason: {season}")
    
    # Filter data for the current season
    season_data = df_master[df_master['season'] == season]
    
    for param in parameters:
        # Drop rows with NaN in 'rank' or the parameter
        subset = season_data[['rank', param]].dropna()
        
        # Ensure there are no zero or negative values for logarithmic scale
        subset = subset[(subset['rank'] > 0) & (subset[param] > 0)]
        
        if subset.shape[0] > 0:  # Ensure there's enough data for regression
            # Perform linear regression between 'rank' (independent) and each parameter (dependent)
            #slope, intercept, r_value, p_value, std_err = stats.linregress((subset['rank']), (subset[param]))
            slope, intercept, r_value, p_value, std_err = stats.linregress(np.log10(subset['rank'][subset['rank'] > 0]), ((subset[param])))
       #     slope, intercept, r_value, p_value, std_err = stats.linregress(np.log10(subset['rank'][subset['rank'] > 0]), (subset[param]))
            # Print the results for each parameter
            print(f"  Parameter: {param}")
            print(f"    Slope: {slope}")
            print(f"    Intercept: {intercept}")
            print(f"    R-value: {r_value}")
            print(f"    P-value: {p_value}")
            print(f"    Standard Error: {std_err}")
            print("\n")
        else:
            print(f"  Insufficient data for parameter {param}")
'''          

# Loop through each parameter to compute p-values
for param in parameters:
    # Drop rows with NaN in 'rank' or the parameter
    subset = df_master[['rank', param]].dropna()
    
    # Ensure there are no zero or negative values for logarithmic scale
    subset = subset[(subset['rank'] > 0) & (subset[param] > 0)]
    
    if subset.shape[0] > 0:  # Ensure there's enough data for regression
        # Perform linear regression between 'rank' (independent) and each parameter (dependent)
        slope, intercept, r_value, p_value, std_err = stats.linregress((subset['rank']), (subset[param]))
        
        # Print the results for each parameter
        print(f"Parameter: {param}")
        print(f"  Slope: {slope}")
        print(f"  Intercept: {intercept}")
        print(f"  R-value: {r_value}")
        print(f"  P-value: {p_value}")
        print(f"  Standard Error: {std_err}")
        print("\n")
    else:
        print(f"Insufficient data for parameter {param}")



import matplotlib as mpl
import seaborn.objects as so
from seaborn import axes_style

fig,ax = plt.subplots(figsize=(5,4))

theme_dict = {**axes_style("whitegrid"),"grid.linestyle":":","legend.frameon":False}

p=(so.Plot(df_master,x="prc",color="class").add(so.Bar(edgecolor="k"), so.Count(), so.Stack())
   .label(x="NPF rank percentiles",y="Number of days",color="NPF event class",linewidth=0)
   .scale(color="Set2")
   .theme(theme_dict)
   .layout(engine="tight")
   )
p.on(ax).plot()
plt.savefig("event_class_vs_percentiles.png",dpi=300,bbox_inches="tight")
plt.show()



import matplotlib.pyplot as plt
import seaborn.objects as so
from seaborn import axes_style
import matplotlib as mpl

# Set up the figure size
fig, ax = plt.subplots(figsize=(6,4))  # Increased the figure size for better readability

# Define a theme with larger fonts and clean gridlines
theme_dict = {**axes_style("whitegrid"),
              "grid.linestyle": ":",
              "legend.frameon": False,
              "axes.labelsize": 25,         # Larger x and y labels
              "axes.titlesize": 25,         # Larger title font size (if added)
              "xtick.labelsize": 25,        # Larger x tick labels
              "ytick.labelsize": 25,        # Larger y tick labels
              "legend.fontsize": 20     # Larger legend font size
             }

# Set global font properties for clarity and professional appearance
mpl.rcParams['font.family'] = 'sans-serif'
mpl.rcParams['font.sans-serif'] = ['Arial']  # Choose a clear, widely supported font

# Create the plot with improved fonts and colors
p = (so.Plot(df_master, x="prc", color="class")
     .add(so.Bar(edgecolor="k"), so.Count(), so.Stack())
     .label(x="Rank percentiles", y="Number of days", color="NPF event class", linewidth=0)
     .scale(color="Set2")  # Aesthetic color palette
     .theme(theme_dict)     # Apply the theme with larger fonts
     .layout(engine="tight"))

# Render the plot
p.on(ax).plot()

plt.tight_layout()
# Save the plot with high resolution
plt.savefig("event_class_vs_percentiles.png", dpi=300, bbox_inches="tight")

# Show the plot
plt.show()
'''